SCIM Provisioning for Organizations
The SCIM API is used by SCIM-enabled Identity Providers (IdPs) to automate provisioning of GitHub organization membership. A API GitHub é baseada na versão 2.0 do padrão SCIM. The GitHub SCIM endpoint that an IdP should use is: https://api.github.com/scim/v2/organizations/{org}/.
Note: The SCIM API is available only to organizations on GitHub Enterprise Cloud with SAML SSO enabled. Para obter mais informações sobre o SCIM, consulte "Sobre o SCIM."
Authenticating calls to the SCIM API
You must authenticate as an owner of a GitHub organization to use its SCIM API. A API espera que um token OAuth 2.0 seja incluído no cabeçalho da Autorização. Você também pode usar um token de acesso pessoal, mas primeiro deve autorizá-lo para uso com sua organização SAML SSO.
Mapping of SAML and SCIM data
O SAML IdP e o cliente SCIM devem usar valores correspondentes ao NameID e userName para cada usuário. Isso permite que um usuário que faz autenticação através do SAML seja vinculado à sua identidade SCIM provisionada.
Supported SCIM User attributes
| Nome | Tipo | Descrição |
|---|---|---|
userName | string | The username for the user. |
name.givenName | string | The first name of the user. |
name.lastName | string | The last name of the user. |
emails | array | List of user emails. |
externalId | string | This identifier is generated by the SAML provider, and is used as a unique ID by the SAML provider to match against a GitHub user. You can find the externalID for a user either at the SAML provider, or using the List SCIM provisioned identities endpoint and filtering on other known attributes, such as a user's GitHub username or email address. |
id | string | Identifier generated by the GitHub SCIM endpoint. |
ativo | boolean | Used to indicate whether the identity is active (true) or should be deprovisioned (false). |
Observação: As URLs de Endpoint para a API SCIM são sensíveis a maiúsculas e minúsculas. Por exemplo, a primeira letra no endpoint Usuários deve ser maiúscula:
GET /scim/v2/organizations/{org}/Users/{scim_user_id}
List SCIM provisioned identities
Retrieves a paginated list of all provisioned organization members, including pending invitations. If you provide the filter parameter, the resources for all matching provisions members are returned.
When a user with a SAML-provisioned external identity leaves (or is removed from) an organization, the account's metadata is immediately removed. However, the returned list of user accounts might not always match the organization or enterprise member list you see on GitHub. This can happen in certain cases where an external identity associated with an organization will not match an organization member:
- When a user with a SCIM-provisioned external identity is removed from an organization, the account's metadata is preserved to allow the user to re-join the organization in the future.
- When inviting a user to join an organization, you can expect to see their external identity in the results before they accept the invitation, or if the invitation is cancelled (or never accepted).
- When a user is invited over SCIM, an external identity is created that matches with the invitee's email address. However, this identity is only linked to a user account when the user accepts the invitation by going through SAML SSO.
The returned list of external identities can include an entry for a null user. These are unlinked SAML identities that are created when a user goes through the following Single Sign-On (SSO) process but does not sign in to their GitHub account after completing SSO:
-
The user is granted access by the IdP and is not a member of the GitHub organization.
-
The user attempts to access the GitHub organization and initiates the SAML SSO process, and is not currently signed in to their GitHub account.
-
After successfully authenticating with the SAML SSO IdP, the
nullexternal identity entry is created and the user is prompted to sign in to their GitHub account:- If the user signs in, their GitHub account is linked to this entry.
- If the user does not sign in (or does not create a new account when prompted), they are not added to the GitHub organization, and the external identity
nullentry remains in place.
get /scim/v2/organizations/{org}/Users
Parâmetros
| Name | Type | In | Description |
|---|---|---|---|
accept |
string | header |
Setting to |
org |
string | path | |
startIndex |
integer | query |
Used for pagination: the index of the first result to return. |
count |
integer | query |
Used for pagination: the number of results to return. |
filter |
string | query |
Filters results using the equals query parameter operator (
To filter results for for the identity with the email
|
Amostras de código
Shell
curl \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users
JavaScript (@octokit/core.js)
await octokit.request('GET /scim/v2/organizations/{org}/Users', {
org: 'org'
})
Response with filter
Status: 200 OK
{
"schemas": [
"urn:ietf:params:scim:api:messages:2.0:ListResponse"
],
"totalResults": 1,
"itemsPerPage": 1,
"startIndex": 1,
"Resources": [
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "5fc0c238-1112-11e8-8e45-920c87bdbd75",
"externalId": "00u1dhhb1fkIGP7RL1d8",
"userName": "[email protected]",
"name": {
"givenName": "Mona",
"familyName": "Octocat"
},
"emails": [
{
"value": "[email protected]",
"primary": true,
"type": "work"
}
],
"active": true,
"meta": {
"resourceType": "User",
"created": "2018-02-13T15:05:24.000-08:00",
"lastModified": "2018-02-13T15:05:55.000-08:00",
"location": "https://api.github.com/scim/v2/organizations/octo-org/Users/5fc0c238-1112-11e8-8e45-920c87bdbd75"
}
}
]
}
Notes
Provision and invite a SCIM user
Provision organization membership for a user, and send an activation email to the email address.
post /scim/v2/organizations/{org}/Users
Parâmetros
| Name | Type | In | Description | ||||||
|---|---|---|---|---|---|---|---|---|---|
accept |
string | header |
Setting to |
||||||
org |
string | path | |||||||
schemas |
array of strings | body |
Required. The SCIM schema URIs. |
||||||
userName |
string | body |
Required. The username for the user. |
||||||
name |
object | body |
Required. undefined |
||||||
name object |
|||||||||
givenName (string) |
Required. The first name of the user. |
familyName (string) |
Required. The last name of the user. |
emailsRequired. List of user emails.
Properties of the emails items
emails itemsvalue (string) |
Required. The email address. |
type (string) |
Required. The type of email address. |
primary (boolean) |
Required. Whether this email address is the primary address. |
Amostras de código
Shell
curl \
-X POST \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users \
-d '{"schemas":["schemas"],"userName":"userName","name":{"givenName":"givenName","familyName":"familyName"},"emails":["[email protected]"]}'
JavaScript (@octokit/core.js)
await octokit.request('POST /scim/v2/organizations/{org}/Users', {
org: 'org',
schemas: [
'schemas'
],
userName: 'userName',
name: {
givenName: 'givenName',
familyName: 'familyName'
},
emails: [
'[email protected]'
]
})
Default response
Status: 201 Created
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "edefdfedf-050c-11e7-8d32",
"externalId": "a7d0f98382",
"userName": "[email protected]",
"name": {
"givenName": "Mona",
"familyName": "Octocat"
},
"emails": [
{
"value": "[email protected]",
"type": "work",
"primary": true
}
],
"active": true,
"meta": {
"resourceType": "User",
"created": "2017-03-09T16:11:13-05:00",
"lastModified": "2017-03-09T16:11:13-05:00",
"location": "https://api.github.com/scim/v2/organizations/octo-org/Users/edefdfedf-050c-11e7-8d32"
}
}
Notes
get /scim/v2/organizations/{org}/Users/{scim_user_id}
Parâmetros
| Name | Type | In | Description |
|---|---|---|---|
accept |
string | header |
Setting to |
org |
string | path | |
scim_user_id |
string | path |
Identifier generated by the GitHub SCIM endpoint. |
Amostras de código
Shell
curl \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users/SCIM_USER_ID
JavaScript (@octokit/core.js)
await octokit.request('GET /scim/v2/organizations/{org}/Users/{scim_user_id}', {
org: 'org',
scim_user_id: 'scim_user_id'
})
Default response
Status: 200 OK
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "edefdfedf-050c-11e7-8d32",
"externalId": "a7d0f98382",
"userName": "[email protected]",
"name": {
"givenName": "Mona",
"familyName": "Octocat"
},
"emails": [
{
"value": "[email protected]",
"type": "work",
"primary": true
}
],
"active": true,
"meta": {
"resourceType": "User",
"created": "2017-03-09T16:11:13-05:00",
"lastModified": "2017-03-09T16:11:13-05:00",
"location": "https://api.github.com/scim/v2/organizations/octo-org/Users/edefdfedf-050c-11e7-8d32"
}
}
Notes
Set SCIM information for a provisioned user
Replaces an existing provisioned user's information. You must provide all the information required for the user as if you were provisioning them for the first time. Any existing user information that you don't provide will be removed. If you want to only update a specific attribute, use the Update an attribute for a SCIM user endpoint instead.
You must at least provide the required values for the user: userName, name, and emails.
Warning: Setting active: false removes the user from the organization, deletes the external identity, and deletes the associated {scim_user_id}.
put /scim/v2/organizations/{org}/Users/{scim_user_id}
Parâmetros
| Name | Type | In | Description | ||||||
|---|---|---|---|---|---|---|---|---|---|
accept |
string | header |
Setting to |
||||||
org |
string | path | |||||||
scim_user_id |
string | path |
Identifier generated by the GitHub SCIM endpoint. |
||||||
schemas |
array of strings | body |
Required. The SCIM schema URIs. |
||||||
userName |
string | body |
Required. The username for the user. |
||||||
name |
object | body |
Required. undefined |
||||||
name object |
|||||||||
givenName (string) |
Required. The first name of the user. |
familyName (string) |
Required. The last name of the user. |
emailsRequired. List of user emails.
Properties of the emails items
emails itemsvalue (string) |
Required. The email address. |
type (string) |
Required. The type of email address. |
primary (boolean) |
Required. Whether this email address is the primary address. |
Amostras de código
Shell
curl \
-X PUT \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users/SCIM_USER_ID \
-d '{"schemas":["schemas"],"userName":"userName","name":{"givenName":"givenName","familyName":"familyName"},"emails":["[email protected]"]}'
JavaScript (@octokit/core.js)
await octokit.request('PUT /scim/v2/organizations/{org}/Users/{scim_user_id}', {
org: 'org',
scim_user_id: 'scim_user_id',
schemas: [
'schemas'
],
userName: 'userName',
name: {
givenName: 'givenName',
familyName: 'familyName'
},
emails: [
'[email protected]'
]
})
Default response
Status: 200 OK
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "edefdfedf-050c-11e7-8d32",
"externalId": "a7d0f98382",
"userName": "[email protected]",
"name": {
"givenName": "Mona",
"familyName": "Octocat"
},
"emails": [
{
"value": "[email protected]",
"type": "work",
"primary": true
}
],
"active": true,
"meta": {
"resourceType": "User",
"created": "2017-03-09T16:11:13-05:00",
"lastModified": "2017-03-09T16:11:13-05:00",
"location": "https://api.github.com/scim/v2/organizations/octo-org/Users/edefdfedf-050c-11e7-8d32"
}
}
Notes
Update an attribute for a SCIM user
Allows you to change a provisioned user's individual attributes. To change a user's values, you must provide a specific Operations JSON format that contains at least one of the add, remove, or replace operations. For examples and more information on the SCIM operations format, see the SCIM specification.
Note: Complicated SCIM path selectors that include filters are not supported. For example, a path selector defined as "path": "emails[type eq \"work\"]" will not work.
Warning: If you set active:false using the replace operation (as shown in the JSON example below), it removes the user from the organization, deletes the external identity, and deletes the associated :scim_user_id.
{
"Operations":[{
"op":"replace",
"value":{
"active":false
}
}]
}
patch /scim/v2/organizations/{org}/Users/{scim_user_id}
Parâmetros
| Name | Type | In | Description |
|---|---|---|---|
accept |
string | header |
Setting to |
org |
string | path | |
scim_user_id |
string | path |
Identifier generated by the GitHub SCIM endpoint. |
schemas |
array of strings | body |
Required. The SCIM schema URIs. |
Operations |
array of objects | body |
Required. Array of SCIM operations. |
Amostras de código
Shell
curl \
-X PATCH \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users/SCIM_USER_ID \
-d '{"schemas":["schemas"],"Operations":[{}]}'
JavaScript (@octokit/core.js)
await octokit.request('PATCH /scim/v2/organizations/{org}/Users/{scim_user_id}', {
org: 'org',
scim_user_id: 'scim_user_id',
schemas: [
'schemas'
],
Operations: [
{}
]
})
Default response
Status: 200 OK
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "edefdfedf-050c-11e7-8d32",
"externalId": "a7d0f98382",
"userName": "[email protected]",
"name": {
"givenName": "Monalisa",
"familyName": "Octocat"
},
"emails": [
{
"value": "[email protected]",
"type": "work",
"primary": true
},
{
"value": "[email protected]",
"type": "home"
}
],
"active": true,
"meta": {
"resourceType": "User",
"created": "2017-03-09T16:11:13-05:00",
"lastModified": "2017-03-09T16:11:13-05:00",
"location": "https://api.github.com/scim/v2/organizations/octo-org/Users/edefdfedf-050c-11e7-8d32"
}
}
Notes
delete /scim/v2/organizations/{org}/Users/{scim_user_id}
Parâmetros
| Name | Type | In | Description |
|---|---|---|---|
accept |
string | header |
Setting to |
org |
string | path | |
scim_user_id |
string | path |
Identifier generated by the GitHub SCIM endpoint. |
Amostras de código
Shell
curl \
-X DELETE \
-H "Accept: application/vnd.github.v3+json" \
https://api.github.com/scim/v2/organizations/ORG/Users/SCIM_USER_ID
JavaScript (@octokit/core.js)
await octokit.request('DELETE /scim/v2/organizations/{org}/Users/{scim_user_id}', {
org: 'org',
scim_user_id: 'scim_user_id'
})
Default Response
Status: 204 No Content